import scipy.io.wavfile as wav
import os

import MFCC
import STFT

import numpy as np
import random
import csv
from scipy import signal
import joblib

"""
ratio_train = 0.8
ratio_valid = 0.1
ratio_test = 0.1
freg = 4000hz
Present == 0
Absent == 1
Unknown == 2
"""
segTime = 1
step = 0.5


def normalize(x):
    x1 = x - np.mean(x)
    x2 = x1 / np.std(x)
    return x2


def butterWorthFilter(x):
    # 这里假设采样频率为2000hz，要滤除10hz以下和400hz以上频率成分，即截至频率为25hz和400hz,则wn1=2*25/2000=0.025,wn2=2*400/2000=0.4。Wn=[0.025,0.4]
    b, a = signal.butter(5, [0.025, 0.4], 'bandpass')
    filtedData = signal.filtfilt(b, a, x)
    return filtedData


# 得到信号谱图:train/valid
def get_2D_data():
    with open('/home/tsz/Cinc2022dataset/train/train.csv') as csvfile:
        reader = csv.reader(csvfile)
        rows = [row for row in reader]
        print(len(rows))
    # x = np.zeros((len(rows), 99, 39, 1), np.float32) # MFCC
    x = np.zeros((len(rows), 129, 33, 1), np.float32) # STFT
    # x = np.zeros((len(rows), 4000), np.float32)
    # y = np.zeros((len(rows), 3), int)
    y = np.zeros((len(rows), 1), int)
    num = np.arange(len(rows))
    np.random.shuffle(num)
    for j in range(len(rows)):
        filename = '/home/tsz/Cinc2022dataset/train/' + str(rows[j][0]) + '.wav'
        # print(rows[j][0])
        sampling_freg, xx = wav.read(filename)

        Xdb = STFT.trans_stft(xx, sampling_freg)
        # Xdb = MFCC.mfcc(xx, sampling_freg)
        # Xdb1 = np.concatenate((Xdb, MFCC.delta(Xdb, 2)), axis=1)
        # Xdb = np.concatenate((Xdb1, MFCC.delta(MFCC.delta(Xdb, 2), 2)), axis=1)

        Xdb = Xdb.astype(np.float32)
        Xdb = Xdb[:, :, np.newaxis]
        # Xdb = Xdb[np.newaxis, :]
        Xdb = Xdb[np.newaxis, :]
        Xdb = normalize(Xdb)

        # label = np.zeros(3)
        #
        # if rows[j][1] == '0':
        #     # 存在：100
        #     label[0] = 1
        # elif rows[j][1] == '1':
        #     # 不存在：010
        #     label[1] = 1
        # elif rows[j][1] == '2':
        #     # 未知： 001
        #     label[2] = 1
        print(Xdb.shape)
        print(int(rows[j][1]))
        x[num[j]] = Xdb
        # y[num[j]] = label
        y[num[j]] = int(rows[j][1])
    ratio = int(len(rows) / 10)
    for i in range(10):
        start = i * ratio
        end = i * ratio + ratio
        if i != 9:
            test_dat_x = x[start:end]
            test_dat_y = y[start:end]
            train_dat_x_1 = x[0:start]
            train_dat_x_2 = x[end:len(rows)]
            train_dat_x = np.concatenate((train_dat_x_1, train_dat_x_2), axis=0)
            train_dat_y_1 = y[0:start]
            train_dat_y_2 = y[end:len(rows)]
            train_dat_y = np.concatenate((train_dat_y_1, train_dat_y_2), axis=0)
            joblib.dump(test_dat_x, open('/home/tsz/Cinc2022dataset/stft/testx' + str(i + 1) + '.dat', "wb"))
            joblib.dump(test_dat_y, open('/home/tsz/Cinc2022dataset/stft/testy' + str(i + 1) + '.dat', "wb"))
            joblib.dump(train_dat_x, open('/home/tsz/Cinc2022dataset/stft/trainx' + str(i + 1) + '.dat', "wb"))
            joblib.dump(train_dat_y, open('/home/tsz/Cinc2022dataset/stft/trainy' + str(i + 1) + '.dat', "wb"))

            # mat2 = np.load("my_data.dat1", allow_pickle=True)
            # print("<9x", test_dat_x.shape)
            # print("<9y", test_dat_y.shape)
            # print('x:', train_dat_x.shape)
            # print('y:', train_dat_y.shape)
        if i == 9:
            test_dat_x = x[start:len(rows)]
            test_dat_y = y[start:len(rows)]
            train_dat_x = x[0:start]
            train_dat_y = y[0:start]
            # print("=9x", test_dat_x.shape)
            # print("=9y", test_dat_y.shape)
            # print('x:', train_dat_x.shape)
            # print('y:', train_dat_y.shape)
            # np.dump会出现内存问题#

            joblib.dump(test_dat_x, open('/home/tsz/Cinc2022dataset/stft/testx' + str(i + 1) + '.dat', "wb"))
            joblib.dump(test_dat_y, open('/home/tsz/Cinc2022dataset/stft/testy' + str(i + 1) + '.dat', "wb"))
            joblib.dump(train_dat_x, open('/home/tsz/Cinc2022dataset/stft/trainx' + str(i + 1) + '.dat', "wb"))
            joblib.dump(train_dat_y, open('/home/tsz/Cinc2022dataset/stft/trainy' + str(i + 1) + '.dat', "wb"))


# 判断相同部位是否测试多个数据
def _is_same(_list, s):
    count = 0
    for i in range(len(_list)):
        if _list[i] == s:
            count = count + 1
    return count


def _judge_label(_list, s):
    if _list[2] == 'Absent':
        return 1
    elif _list[2] == 'Unknown':
        return 2
    elif _list[2] == 'Present':
        if s in _list[3]:
            return 0
        else:
            return 1


# 得到分割数据
def _get_file():
    all_wav, all_id = [], []
    with open("/home/tsz/Cinc2022dataset/training_data.csv") as f:
        f_csv = csv.reader(f)
        headers = next(f_csv)
        print(headers)
        for row in f_csv:
            # print(row[0])
            useful_mes = []
            useful_mes.append(row[0])
            useful_mes.append(row[1].split('+'))
            useful_mes.append(row[7])
            useful_mes.append(row[8].split('+'))
            all_id.append(useful_mes)
        # print(all_id)
        # print(len(all_id))

        f_train = open('/home/tsz/Cinc2022dataset/train/train.csv', 'a')
        f_test = open('/home/tsz/Cinc2022dataset/test/test.csv', 'a')

        # train_data/valid_data
        n = 1
        for i in range(0, int(len(all_id) * 0.9)):
            print(all_id[i])
            # print(i)
            c = 0
            while c < len(all_id[i][1]):
                print(all_id[i][1])
                flag = _is_same(all_id[i][1], all_id[i][1][c])
                if flag == 1:
                    sampling_freg, x = wav.read(
                        "/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][c] + '.wav')
                    print(x)
                    print("/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][c] + '.wav')
                    label = _judge_label(all_id[i], all_id[i][1][c])
                    _len = int(len(x) / (sampling_freg * step))
                    for r in range(_len + 1):
                        x_meg = x[int(r * sampling_freg * step):int(r * sampling_freg * step + segTime * sampling_freg)]
                        if (len(x_meg) == segTime * sampling_freg):
                            wav.write('/share/tsz/Cinc2022dataset/train/' + str(n) + '.wav', sampling_freg, x_meg)
                            output = "%s,%s\n" % (str(n), label)
                            f_train.write(output)
                            n = n + 1
                        if (len(x_meg) < segTime * sampling_freg):
                            x_meg = x[-(segTime * sampling_freg):]
                            wav.write('/share/tsz/Cinc2022dataset/train/' + str(n) + '.wav', sampling_freg, x_meg)
                            output = "%s,%s\n" % (str(n), label)
                            f_train.write(output)
                            n = n + 1
                            break
                    c = c + 1
                else:
                    for k in range(flag):
                        sampling_fre, x = wav.read(
                            "/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][
                                c] + '_' + str(k + 1) + '.wav')
                        label = _judge_label(all_id[i], all_id[i][1][c])
                        _len = int(len(x) / (sampling_fre * step))
                        for r in range(_len + 1):
                            x_meg = x[int(k * sampling_freg * step):int(
                                k * sampling_freg * step + segTime * sampling_freg)]
                            if (len(x_meg) == segTime * sampling_freg):
                                wav.write('/share/tsz/Cinc2022dataset/train/' + str(n) + '.wav', sampling_freg, x_meg)
                                output = "%s,%s\n" % (str(n), label)
                                f_train.write(output)
                                n = n + 1
                            if (len(x_meg) < segTime * sampling_freg):
                                x_meg = x[-(segTime * sampling_freg):]
                                wav.write('/share/tsz/Cinc2022dataset/train/' + str(n) + '.wav', sampling_freg, x_meg)
                                output = "%s,%s\n" % (str(n), label)
                                f_train.write(output)
                                n = n + 1
                                break
                        print(x)
                        print("/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][
                            c] + '_' + str(k + 1) + '.wav')
                        c = c + 1

        # test_data
        for i in range(int(len(all_id) * 0.9), int(len(all_id))):
            print(all_id[i])
            # print(i)
            c = 0
            while c < len(all_id[i][1]):
                print(all_id[i][1])
                flag = _is_same(all_id[i][1], all_id[i][1][c])
                if flag == 1:
                    sampling_freg, x = wav.read(
                        "/home/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][c] + '.wav')
                    label = _judge_label(all_id[i], all_id[i][1][c])
                    wav.write('/home/tsz/Cinc2022dataset/test1/' + all_id[i][0] + '_' + all_id[i][1][c] + '.wav',
                              sampling_freg, x)
                    output = "%s,%s\n" % (all_id[i][0] + '_' + all_id[i][1][c], label)
                    f_test.write(output)
                    # print(x)
                    # print("/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][c] + '.wav')
                    c = c + 1
                else:
                    for k in range(flag):
                        sampling_freg, x = wav.read(
                            "/home/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][
                                c] + '_' + str(k + 1) + '.wav')

                        label = _judge_label(all_id[i], all_id[i][1][c])
                        wav.write('/home/tsz/Cinc2022dataset/test1/' + all_id[i][0] + '_' + all_id[i][1][
                            c] + '_' + str(k + 1) + '.wav',
                                  sampling_freg, x)

                        output = "%s,%s\n" % (all_id[i][0] + '_' + all_id[i][1][
                            c] + '_' + str(k + 1), label)

                        f_test.write(output)
                        # print(x)
                        # print("/share/tsz/Cinc2022dataset/training_data/" + all_id[i][0] + '_' + all_id[i][1][c] + '_' + str(k + 1) + '.wav')
                        c = c + 1


def _balance_data():
    f_train = open('/home/tsz/Cinc2022dataset/balance_train/label.csv', 'a')

    with open('/home/tsz/Cinc2022dataset/train/train.csv') as csvfile:
        count = 0
        flag = 1
        reader = csv.reader(csvfile)
        rows = [row for row in reader]
        print(rows[0])
        for i in range(len(rows)):
            if rows[i][1] == '2':
                sampling_freg, x = wav.read('/home/tsz/Cinc2022dataset/train/' + rows[i][0] + '.wav')
                wav.write('/home/tsz/Cinc2022dataset/balance_train/' + str(flag) + '.wav', sampling_freg, x)
                output = "%s,%s\n" % (str(flag), rows[i][1])
                f_train.write(output)
                flag = flag + 1
                count = count + 1
        print(count)
        print(flag)
        count = count * 2
        for j in range(len(rows)):
            if rows[j][1] == '1':
                sampling_freg, x = wav.read('/home/tsz/Cinc2022dataset/train/' + rows[j][0] + '.wav')
                wav.write('/home/tsz/Cinc2022dataset/balance_train/' + str(flag) + '.wav', sampling_freg, x)
                output = "%s,%s\n" % (str(flag), rows[j][1])
                f_train.write(output)
                flag = flag + 1
                count = count - 1
            if rows[j][1] == '0':
                sampling_freg, x = wav.read('/home/tsz/Cinc2022dataset/train/' + rows[j][0] + '.wav')
                wav.write('/home/tsz/Cinc2022dataset/balance_train/' + str(flag) + '.wav', sampling_freg, x)
                output = "%s,%s\n" % (str(flag), rows[j][1])
                f_train.write(output)
                flag = flag + 1
                count = count - 1
            if count == 0:
                break
        print(count)
        print(flag)


if __name__ == '__main__':
    _get_file()
    # get_2D_data()
    # _balance_data()
    print("使用函数")
